// array.cpp

#include "jpnslisp.h"

extern CELL *NILCell,*TCell,*CHARACTER,*COLDIRECTION,*COLINPUT,*COLOUTPUT,*STRING,*LIST,*FUNCTION;

extern char lineStr[BUFLEN];

CELL *jcons(CELL *car,CELL *cdr)
{
    CELL *c;

    c = getCell();
    c->attr = 'l';
    c->car = car;
    c->cdr = cdr;
    return c;
}

CELL *jnth(long n,CELL *c)
{
    if (c->attr != 'l') return NULL;
    if (n == 0L) return c->car;
    return jnth(n - 1,c->cdr);
}

CELL *jprenth(long n,CELL *c)
{
    if (c->attr != 'l') return NULL;
    if (n == 0L) return c;
    return jprenth(n - 1,c->cdr);
}

long jnlength(CELL *c)
{
    long i = 0;

    for (;;) {
	if (c->attr != 'l') return i;
	c = c->cdr;
	i++;
    }
}

CELL *SetArray(CELL *top,SYMVAL *loc,long locn)
{
    CELL *c;

    if ((top->cdr)->attr != 'l') goto serror;
    c = eval((top->cdr)->car,loc,locn);
    if (c == NULL) goto serror;
    if (c->attr != 'l') goto serror;
    c->attr = 'a';
    return c;

  serror:
    printf("G[: z^ɐݒł܂B\n");
    return NULL;
}


CELL *ArrayCar(CELL *a)
{
    if (a->attr != 'a') { puts("zł͂܂"); return NULL; }
    return a->car;
}

CELL *ArrayCdr(CELL *a)
{
    if (a->attr != 'a') { puts("zł͂܂"); return NULL; }
    return a->cdr;
}

CELL *get1char(unsigned char *m)
{
    unsigned char c1,c2;

    c1 = *m;
    if (isKanji(&c1)) c2 = *(m + 1);
    else {
	c2 = NULL;
	if (c1 == '\\') {
	    if (*(m + 1) == '\\') ;
	    else if (*(m + 1) == '"') {
		c1 = '"';
	    }
	    else {
		c1 = *(m + 1);
	    }
	}
    }
    return getMojiCell(c1,c2);
}

unsigned char *getRestchar(unsigned char *m)
{
    unsigned char c1,c2;

    c1 = *m;
    if (isKanji(&c1)) m++;
    else {
	if (c1 == '\\') {
	    if (*(m + 1) == '\\') m++;
	    else if (*(m + 1) == '"') {
		m++;
	    }
	    else {
		m++;
	    }
	}
    }
    m++;
    return m;
}

CELL *getMojiretsuCell(char *m)
{
    CELL *p,*i,*c,*head,*q;
    AINT *k;

    i = getCell();
    i->attr = 'i';
    k = getInt(1L);
    i->car = (CELL *)k;

    head = p = getCell();
    p->attr = 'a';
    p->car = i;
    q = getCell();
    q->car = CHARACTER;
    p->cdr = q;
    m++;
    for (;;) {
	p = q;
	if (*m == '"') break;
	c =get1char(m);
	m = getRestchar(m);
	q = getCell();
	q->attr = 'l';
	q->car = c;
	p->cdr = q;
    }
    p = NILCell;
    if (p == NULL) return NULL; // dummy
    return head;
}

BOOL toPathMojiretsu(CELL *a,unsigned char *name,int maxlen)
{
    int i;

    if (a->attr != 'a') return FALSE;
    if ((a->car)->attr != 'i') return FALSE;
    if (((AINT *)((a->car)->car))->f != 1L) return FALSE;
    a = a->cdr;
    if (a->car != CHARACTER) return FALSE;
    a = a->cdr;
    if (jnlength(a) < 1) return FALSE;
    i = 0;
    for (;;) {
	if (i >= maxlen) return FALSE;
	if (jnlength(a) == 0) break;
	if (a->attr != 'l') return FALSE;
	if ((a->car)->attr != 'm') return FALSE;
	if ((a->car)->cdr == NULL) name[i] = (unsigned char)((a->car)->car);
	else {
	    name[i++] = (unsigned char)((a->car)->car);
	    if (i >= maxlen) return FALSE;
	    name[i] = (unsigned char)((a->car)->cdr);
	}
	i++;
	a = a->cdr;
    }
    name[i] = '\0';
    return TRUE;
}

void PutString(CELL *a,FILE *fp)  // a = (#\h #\e #\l #\l #\o) etc.
{
    fprintf(fp,"\"");
    for (;;) {
	if (jnlength(a) == 0) break;
	if (a->attr != 'l') return;
	if ((a->car)->attr != 'm') return;
	if ((a->car)->cdr == NULL) {
	    if ((unsigned char)((a->car)->car) == '"') fprintf(fp,"\\");
	    else if ((unsigned char)((a->car)->car) == '\\') fprintf(fp,"\\");
	    fprintf(fp,"%c",(unsigned char)((a->car)->car));
	}
	else {
	    fprintf(fp,"%c",(unsigned char)((a->car)->car));
	    fprintf(fp,"%c",(unsigned char)((a->car)->cdr));
	}
	a = a->cdr;
    }
    fprintf(fp,"\"");
}

void PutStringC(CELL *a,FILE *fp)  // a = (#\h #\e #\l #\l #\o) etc.
{
    for (;;) {
	if (jnlength(a) == 0) break;
	if (a->attr != 'l') return;
	if ((a->car)->attr != 'm') return;
	if ((a->car)->cdr == NULL) {
	    fprintf(fp,"%c",(unsigned char)((a->car)->car));
	}
	else {
	    fprintf(fp,"%c",(unsigned char)((a->car)->car));
	    fprintf(fp,"%c",(unsigned char)((a->car)->cdr));
	}
	a = a->cdr;
    }
}

CELL *topen(CELL *p,SYMVAL *loc,long locn)
{
    unsigned char pathname[PATH_LEN + 1];
    char mode[5];
    FILE *fp;
    CELL *q;

    if (p->attr != 'l') goto serror;
    if ((q = eval(p->car,loc,locn)) == NULL) goto serror;
    if (q->attr != 's' && q->attr != 'a') goto serror;
    if (q->attr == 's') { strncpy(pathname,(char *)(q->car),PATH_LEN); pathname[PATH_LEN] = '\0'; }
    else if (q->attr == 'a') {
	if(!toPathMojiretsu(q,pathname,PATH_LEN)) goto serror;
    }
    p = p->cdr;
    if (p->attr != 'l') {
	strcpy(mode,"rb");
    }
    else if (p->car == COLDIRECTION) {
	p = p->cdr;
        if (p->attr != 'l') strcpy(mode,"rb");
        else {
            q = eval(p->car,loc,locn);
	    if (q == NULL) goto serror;
            if (q == COLINPUT) strcpy(mode,"rb");
	    else if (q == COLOUTPUT) strcpy(mode,"wb");
            else strcpy(mode,"rb");
	}
    }
    else strcpy(mode,"rb");
    fp = fopen(pathname,mode);
    if (fp == NULL) { printf("G[: t@CJƂł܂B\n"); return NILCell; }
    return SetFilePointer(fp);
serror:
    return NILCell;
}

CELL *ReadLine(void)
{
    char *p;
    CELL *q,*r,*r2;

    fgets(lineStr + 1,BUFLEN - 1,stdin);
    p = lineStr;
    *p++ = '"';
    while (*p != '\0') {
	if (*p == '\n') { *p = '\0'; break; }
	else if (*p == '\\') { p++; slide(p,1); *p++ = '\\'; }
	else if (*p == '"') { *p++ = '\\'; slide(p,1); *p++ = '"'; }
	else if (isKanji(p)) { p += 2; }
	else p++;
    }
    strcat(lineStr,"\"");
    q = getMojiretsuCell(lineStr);

    r = getCell();
    r2 = getCell();
    r->attr = 'l';
    r->car = q;
    r->cdr = r2;
    r2->attr = 'l';
    r2->car = NILCell;
    r2->cdr = NILCell;
    q->mtop = r;
    return q;
}

CELL *StringEqual(CELL *a1,CELL *a2)
{
    if (a1->attr != 'a' || a2->attr != 'a') return NILCell;
    if ((a1->car)->attr != 'i' || (a2->car)->attr != 'i') return NILCell;
    if (((AINT *)((a1->car)->car))->f != 1 || ((AINT *)((a2->car)->car))->f != 1) return NILCell;
    a1 = a1->cdr;
    a2 = a2->cdr;
    if (a1->car != CHARACTER || a2->car != CHARACTER) return NILCell;
    a1 = a1->cdr;
    a2 = a2->cdr;
    for (;;) {
	if (a1->attr != 'l') {
	    if (a2->attr != 'l') return TCell;
	    else return NILCell;
	}
	if (a2->attr != 'l') {
	    if (a1->attr != 'l') return TCell;
	    else return NILCell;
	}
	if ((unsigned char)((a1->car)->car) != (unsigned char)((a2->car)->car)) return NILCell;
	if ((unsigned char)((a1->car)->cdr) != (unsigned char)((a2->car)->cdr)) return NILCell;
	a1 = a1->cdr;
	a2 = a2->cdr;
    }
}

BOOL isAllMoji(CELL *p)
{
    for (;;) {
	if (p->attr != 'l') {
	    if (p != NILCell) return FALSE;
	    else return TRUE;
	}
	if ((p->car)->attr != 'm') return FALSE;
	p = p->cdr;
    }
}

CELL *coerce(CELL *p,SYMVAL *loc,long locn)
{
    CELL *x,*y,*q,*i,*head;
    AINT *k;

    if (p->attr != 'l') goto serror;
    x = p->car;
    x = eval(x,loc,locn);
    if (x == NULL) return NULL;
    p = p->cdr;
    if (p->attr != 'l') goto serror;
    y = p->car;
    y = eval(y,loc,locn);
    if (y == NULL) return NULL;
    if (y == STRING) {
	if (x->attr != 'l' && x != NILCell) goto serror;
	if (!isAllMoji(x)) goto serror;
	i = getCell();
	i->attr = 'i';
	k = getInt(1L);
	i->car = (CELL *)k;
	head = p = getCell();
	p->attr = 'a';
	p->car = i;
	q = getCell();
	q->car = CHARACTER;
	p->cdr = q;
	q->cdr = Copy(x);
	return head;
    }
    else if (y == LIST) {
	if (x->attr != 'a' || (x->car)->attr != 'i' || ((AINT *)((x->car)->car))->f != 1L) goto serror;
	x = x->cdr;
	if (x->car != CHARACTER) goto serror;
	return Copy(x->cdr);
    }
    else if (y == FUNCTION) return x;

serror:
    printf("G[: COERCE: @ԈĂ܂B\n");
    return NULL;
}

CELL *tchar(CELL *p,SYMVAL *loc,long locn)
{
    CELL *q,*r;
    long k,i,len;
    long cnt;
    char *ch;

    if (p->attr != 'l') goto serror;
    q = p->car;
    q = eval(q,loc,locn);
    if (q == NULL) return NULL;
    p = p->cdr;
    if (p->attr != 'l') goto serror;
    r = p->car;
    r = eval(r,loc,locn);
    if (r == NULL) return NULL;
    if (q->attr != 'a') goto serror;
    if (r->attr != 'i') goto serror;
    k = ((AINT *)(r->car))->f;
    if (k < 0) goto serror;
    if ((q->car)->attr != 'i' || ((AINT *)((q->car)->car))->f != 1L) goto serror;
    q = q->cdr;
    if (q->car != CHARACTER) goto serror;
    q = q->cdr;
    cnt = 0;
    for (;;) {
	if (q->attr != 'l') return NILCell;
	if (cnt == k) return q->car;
	q = q->cdr;
	cnt++;
    }
/*
    len = strlen((char *)(q->car));
    len -= 2;
    ch = (char *)(q->car) + 1;
    for (i = 0;i < len;i++) {
	if (cnt == k) {
	    if (isKanji(ch)) {
		return getMojiCell(*ch,*(ch + 1));
	    }
	    else if (*ch == '\\' && *(ch + 1) == '"') return getMojiCell(*(ch + 1),NULL);
	    else if (*ch == '\\' && *(ch + 1) == '\\') return getMojiCell(*(ch + 1),NULL);
	    else return getMojiCell(*ch,NULL);
	}
        if (*ch == '\\' && *(ch + 1) == '"') {
	    cnt++; i++; ch += 2;
	}
        else if (*ch == '\\' && *(ch + 1) == '\\') {
	    cnt++; i++; ch += 2;
	}
	else if (isKanji(ch)) {
	    cnt++; i++; ch += 2;
	}
	else { cnt++; ch++; }
    }
*/

serror:
    printf("G[: @ԈĂ܂B\n");
    return NULL;
}
